gtkmm: Gtk::Gesture Class Reference

gtkmm 3.24.6

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::Gesture Class Reference
Event Controllers and Gestures

Abstract base class for gestures. More...

`#include <gtkmm/gesture.h>`

Inheritance diagram for Gtk::Gesture:
[legend]

## Public Member Functions
| Gesture (Gesture && src) noexcept
Gesture & | operator= (Gesture && src) noexcept
| ~Gesture () noexcept override
GtkGesture * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkGesture * | gobj () const
| Provides access to the underlying C GObject. More...
GtkGesture * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::RefPtr< Gdk::Device > | get_device ()
| Returns the master Gdk::Device that is currently operating on gesture, or `nullptr` if the gesture is not being interacted. More...
Glib::RefPtr< const Gdk::Device > | get_device () const
| Returns the master Gdk::Device that is currently operating on gesture, or `nullptr` if the gesture is not being interacted. More...
bool | set_state (EventSequenceState state)
| Sets the state of all sequences that gesture is currently interacting with. More...
EventSequenceState | get_sequence_state (GdkEventSequence *sequence) const
| Returns the sequence state, as seen by gesture. More...
bool | set_sequence_state (GdkEventSequence *sequence, EventSequenceState state)
| Sets the state of sequence in gesture. More...
std::vector< const GdkEventSequence * > | get_sequences () const
| Returns the list of GdkEventSequences currently being interpreted. More...
GdkEventSequence * | get_last_updated_sequence ()
| Returns the Gdk::EventSequence that was last updated on gesture. More...
const GdkEventSequence * | get_last_updated_sequence () const
| Returns the Gdk::EventSequence that was last updated on gesture. More...
bool | handles_sequence (GdkEventSequence *sequence) const
| Returns `true` if gesture is currently handling events corresponding to sequence. More...
const GdkEvent * | get_last_event (GdkEventSequence *sequence) const
| Returns the last event that was processed for sequence. More...
bool | get_point (GdkEventSequence *sequence, double & x, double & y) const
| If sequence is currently being interpreted by gesture, this function returns `true` and fills in x and y with the last coordinates stored for that event sequence. More...
bool | get_bounding_box (Gdk::Rectangle & rect) const
| If there are touch sequences being currently handled by gesture, this function returns `true` and fills in rect with the bounding box containing all active touches. More...
bool | get_bounding_box_center (double & x, double & y) const
| If there are touch sequences being currently handled by gesture, this function returns `true` and fills in x and y with the center of the bounding box containing all active touches. More...
bool | is_active () const
| Returns `true` if the gesture is currently active. More...
bool | is_recognized () const
| Returns `true` if the gesture is currently recognized. More...
Glib::RefPtr< Gdk::Window > | get_window ()
| Returns the user-defined window that receives the events handled by gesture. More...
Glib::RefPtr< const Gdk::Window > | get_window () const
| Returns the user-defined window that receives the events handled by gesture. More...
void | set_window (const Glib::RefPtr< Gdk::Window > & window)
| Sets a specific window to receive events about, so gesture will effectively handle only events targeting window, or a child of it. More...
void | unset_window ()
| Undoes the effect of previous calls to set_window(), so the gesture will handle events targeting any Gdk::Window that pertains to Gtk::EventController::get_widget(). More...
void | group (const Glib::RefPtr< Gesture > & group_gesture)
| Adds gesture to the same group than group_gesture. More...
void | ungroup ()
| Separates gesture into an isolated group. More...
std::vector< Glib::RefPtr< Gesture > > | get_group ()
| Returns all gestures in the group of gesture. More...
std::vector< Glib::RefPtr< const Gesture > > | get_group () const
| Returns all gestures in the group of gesture. More...
bool | is_grouped_with (const Glib::RefPtr< Gesture > & other) const
| Returns `true` if both gestures pertain to the same group. More...
Glib::SignalProxy< void, GdkEventSequence * > | signal_begin ()
Glib::SignalProxy< void, GdkEventSequence * > | signal_end ()
Glib::SignalProxy< void, GdkEventSequence * > | signal_update ()
Glib::SignalProxy< void, GdkEventSequence * > | signal_cancel ()
Glib::SignalProxy< void, GdkEventSequence *, EventSequenceState > | signal_sequence_state_changed ()
Glib::PropertyProxy_ReadOnly< unsigned int > | property_n_points () const
| The number of touch points that trigger recognition on this gesture,. More...
Glib::PropertyProxy< Glib::RefPtr< Gdk::Window > > | property_window ()
| If non-`nullptr`, the gesture will only listen for events that happen on this Gdk::Window, or a child of it. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::Window > > | property_window () const
| If non-`nullptr`, the gesture will only listen for events that happen on this Gdk::Window, or a child of it. More...
Public Member Functions inherited from Gtk::EventController
| EventController (EventController && src) noexcept
EventController & | operator= (EventController && src) noexcept
| ~EventController () noexcept override
GtkEventController * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkEventController * | gobj () const
| Provides access to the underlying C GObject. More...
GtkEventController * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Widget * | get_widget ()
| Returns the Gtk::Widget this controller relates to. More...
const Widget * | get_widget () const
| Returns the Gtk::Widget this controller relates to. More...
bool | handle_event (const GdkEvent * event)
| Feeds an events into controller, so it can be interpreted and the controller actions triggered. More...
void | reset ()
| Resets the controller to a clean state. More...
PropagationPhase | get_propagation_phase () const
| Gets the propagation phase at which controller handles events. More...
void | set_propagation_phase (PropagationPhase phase)
| Sets the propagation phase at which a controller handles events. More...
Glib::PropertyProxy_ReadOnly< Widget * > | property_widget () const
| The widget receiving the Gdk::Events that the controller will handle. More...
Glib::PropertyProxy< PropagationPhase > | property_propagation_phase ()
| The propagation phase at which this controller will handle events. More...
Glib::PropertyProxy_ReadOnly< PropagationPhase > | property_propagation_phase () const
| The propagation phase at which this controller will handle events. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void > &&slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, sigc::slot< void > &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::EventController
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| Gesture ()
| There is no create() method that corresponds to this constructor, because only derived classes shall be created. More...
Protected Member Functions inherited from Gtk::EventController
| EventController ()
| There is no create() method that corresponds to this constructor, because only derived classes shall be created. More...
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::Gesture > | wrap (GtkGesture * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::EventController
Glib::RefPtr< Gtk::EventController > | wrap (GtkEventController * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

Abstract base class for gestures.

This is the base object for gesture recognition. Although this object is quite generalized to serve as a base for multi-touch gestures, it is suitable to implement single-touch and pointer-based gestures (using the special GdkEventSequence value for these).

The number of touches that a Gesture need to be recognized is controlled by the n-points property. If a gesture is keeping track of less or more than that number of sequences, it won't check whether the gesture is recognized.

As soon as the gesture has the expected number of touches, the gesture will run check signal regularly on input events until the gesture is recognized. The criteria to consider a gesture as "recognized" is left to Gesture subclasses.

A recognized gesture will then emit the following signals:

- signal_begin() when the gesture is recognized.
- A number of signal_update(), whenever an input event is processed.
- signal_end() when the gesture is no longer recognized.

## Event propagation

In order to receive events, a gesture needs to either set a propagation phase through EventController::set_propagation_phase(), or feed those manually through EventController::handle_event().

In the capture phase, events are propagated from the toplevel down to the target widget, and gestures that are attached to containers above the widget get a chance to interact with the event before it reaches the target.

After the capture phase, GTK+ emits the traditional Widget::signal_button_press_event(), Widget::signal_button_release_event(), Widget::signal_touch_event(), etc. Gestures with the Gtk::PHASE_TARGET phase are fed events from the default Widget::signal_event() handlers.

In the bubble phase, events are propagated up from the target widget to the toplevel, and gestures that are attached to containers above the widget get a chance to interact with events that have not been handled yet.

## States of a sequence

Whenever input interaction happens, a single event may trigger a cascade of Gestures, both across the parents of the widget receiving the event and parallelly within an individual widget. It is a responsibility of the widgets using those gestures to set the state of touch sequences accordingly in order to enable cooperation of gestures around the GdkEventSequences triggering those.

Within a widget, gestures can be grouped through group(). Grouped gestures synchronize the state of sequences, so calling set_sequence_state() on one will effectively propagate the state throughout the group.

By default, all sequences start out in the Gtk::EVENT_SEQUENCE_NONE state. Sequences in this state trigger the gesture event handler, but event propagation will continue unstopped by gestures.

If a sequence enters into the Gtk::EVENT_SEQUENCE_DENIED state, the gesture group will effectively ignore the sequence, letting events go unstopped through the gesture, but the "slot" will still remain occupied while the touch is active.

If a sequence enters in the Gtk::EVENT_SEQUENCE_CLAIMED state, the gesture group will grab all interaction on the sequence, by:

- Setting the same sequence to Gtk::EVENT_SEQUENCE_DENIED on every other gesture group within the widget, and every gesture on parent widgets in the propagation chain.
- emitting signal_cancel() on every gesture in widgets underneath in the propagation chain.
- Stopping event propagation after the gesture group handles the event.

Note
  If a sequence is set early to Gtk::EVENT_SEQUENCE_CLAIMED on Gdk::TOUCH_BEGIN/Gdk::BUTTON_PRESS (so those events are captured before reaching the event widget, this implies Gtk::PHASE_CAPTURE), one similar event will be emulated if the sequence changes to Gtk::EVENT_SEQUENCE_DENIED. This way event coherence is preserved before event propagation is unstopped again.

Sequence states can't be changed freely, see set_sequence_state() to know about the possible lifetimes of a GdkEventSequence.

Since gtkmm 3.14:

## Constructor & Destructor Documentation

## ◆ Gesture() [1/2]

Gtk::Gesture::Gesture | ( | Gesture && | src | ) |
| noexcept

## ◆ ~Gesture()

Gtk::Gesture::~Gesture | ( |  | ) |
| overridenoexcept

## ◆ Gesture() [2/2]

Gtk::Gesture::Gesture | ( |  | ) |
| protected

There is no create() method that corresponds to this constructor, because only derived classes shall be created.

## Member Function Documentation

## ◆ get_bounding_box()

bool Gtk::Gesture::get_bounding_box | ( | Gdk::Rectangle & | rect | ) | const

If there are touch sequences being currently handled by gesture, this function returns `true` and fills in rect with the bounding box containing all active touches.

Otherwise, `false` will be returned.

Note
  This function will yield unexpected results on touchpad gestures. Since there is no correlation between physical and pixel distances, these will look as if constrained in an infinitely small area, rect width and height will thus be 0 regardless of the number of touchpoints.

Since gtkmm 3.14:

Parameters

  rect | Bounding box containing all active touches.

Returns
  `true` if there are active touches, `false` otherwise.

## ◆ get_bounding_box_center()

bool Gtk::Gesture::get_bounding_box_center | ( | double & | x,
|  | double & | y
| ) |  | const

If there are touch sequences being currently handled by gesture, this function returns `true` and fills in x and y with the center of the bounding box containing all active touches.

Otherwise, `false` will be returned.

Since gtkmm 3.14:

Parameters

  x | X coordinate for the bounding box center.
  y | Y coordinate for the bounding box center.

Returns
  `false` if no active touches are present, `true` otherwise.

## ◆ get_device() [1/2]

Glib::RefPtr< Gdk::Device > Gtk::Gesture::get_device | ( |  | ) |

Returns the master Gdk::Device that is currently operating on gesture, or `nullptr` if the gesture is not being interacted.

Since gtkmm 3.14:

Returns
  A Gdk::Device, or `nullptr`.

## ◆ get_device() [2/2]

Glib::RefPtr< const Gdk::Device > Gtk::Gesture::get_device | ( |  | ) | const

Returns the master Gdk::Device that is currently operating on gesture, or `nullptr` if the gesture is not being interacted.

Since gtkmm 3.14:

Returns
  A Gdk::Device, or `nullptr`.

## ◆ get_group() [1/2]

std::vector< Glib::RefPtr< Gesture > > Gtk::Gesture::get_group | ( |  | ) |

Returns all gestures in the group of gesture.

Since gtkmm 3.14:

Returns
  The list of Gtk::Gestures.

## ◆ get_group() [2/2]

std::vector< Glib::RefPtr< const Gesture > > Gtk::Gesture::get_group | ( |  | ) | const

Returns all gestures in the group of gesture.

Since gtkmm 3.14:

Returns
  The list of Gtk::Gestures.

## ◆ get_last_event()

const GdkEvent * Gtk::Gesture::get_last_event | ( | GdkEventSequence * | sequence | ) | const

Returns the last event that was processed for sequence.

Note that the returned pointer is only valid as long as the sequence is still interpreted by the gesture. If in doubt, you should make a copy of the event.

Parameters

  sequence | A Gdk::EventSequence.

Returns
  The last event from sequence.

## ◆ get_last_updated_sequence() [1/2]

GdkEventSequence * Gtk::Gesture::get_last_updated_sequence | ( |  | ) |

Returns the Gdk::EventSequence that was last updated on gesture.

Since gtkmm 3.14:

Returns
  The last updated sequence.

## ◆ get_last_updated_sequence() [2/2]

const GdkEventSequence * Gtk::Gesture::get_last_updated_sequence | ( |  | ) | const

Returns the Gdk::EventSequence that was last updated on gesture.

Since gtkmm 3.14:

Returns
  The last updated sequence.

## ◆ get_point()

bool Gtk::Gesture::get_point | ( | GdkEventSequence * | sequence,
|  | double & | x,
|  | double & | y
| ) |  | const

If sequence is currently being interpreted by gesture, this function returns `true` and fills in x and y with the last coordinates stored for that event sequence.

The coordinates are always relative to the widget allocation.

Since gtkmm 3.14:

Parameters

  sequence | A Gdk::EventSequence, or `nullptr` for pointer events.
  x | Return location for X axis of the sequence coordinates.
  y | Return location for Y axis of the sequence coordinates.

Returns
  `true` if sequence is currently interpreted.

## ◆ get_sequence_state()

EventSequenceState Gtk::Gesture::get_sequence_state | ( | GdkEventSequence * | sequence | ) | const

Returns the sequence state, as seen by gesture.

Since gtkmm 3.14:

Parameters

  sequence | A Gdk::EventSequence.

Returns
  The sequence state in gesture.

## ◆ get_sequences()

std::vector< const GdkEventSequence * > Gtk::Gesture::get_sequences | ( |  | ) | const

Returns the list of GdkEventSequences currently being interpreted.

Since gtkmm 3.14:

Returns
  A std::vector of GdkEventSequence pointers. The GdkEventSequences are owned by GTK+ and must not be freed or modified.

## ◆ get_type()

static GType Gtk::Gesture::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ get_window() [1/2]

Glib::RefPtr< Gdk::Window > Gtk::Gesture::get_window | ( |  | ) |

Returns the user-defined window that receives the events handled by gesture.

See set_window() for more information.

Since gtkmm 3.14:

Returns
  The user defined window, or `nullptr` if none.

## ◆ get_window() [2/2]

Glib::RefPtr< const Gdk::Window > Gtk::Gesture::get_window | ( |  | ) | const

Returns the user-defined window that receives the events handled by gesture.

See set_window() for more information.

Since gtkmm 3.14:

Returns
  The user defined window, or `nullptr` if none.

## ◆ gobj() [1/2]

GtkGesture * Gtk::Gesture::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkGesture * Gtk::Gesture::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkGesture * Gtk::Gesture::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ group()

void Gtk::Gesture::group | ( | const Glib::RefPtr< Gesture > & | group_gesture | ) |

Adds gesture to the same group than group_gesture.

Gestures are by default isolated in their own groups.

When gestures are grouped, the state of Gdk::EventSequences is kept in sync for all of those, so calling set_sequence_state(), on one will transfer the same value to the others.

Groups also perform an "implicit grabbing" of sequences, if a Gdk::EventSequence state is set to Gtk::EVENT_SEQUENCE_CLAIMED on one group, every other gesture group attached to the same Gtk::Widget will switch the state for that sequence to Gtk::EVENT_SEQUENCE_DENIED.

Since gtkmm 3.14:

Parameters

  group_gesture | Gtk::Gesture to group gesture with.

## ◆ handles_sequence()

bool Gtk::Gesture::handles_sequence | ( | GdkEventSequence * | sequence | ) | const

Returns `true` if gesture is currently handling events corresponding to sequence.

Since gtkmm 3.14:

Parameters

  sequence | A Gdk::EventSequence or `nullptr`.

Returns
  `true` if gesture is handling sequence, `false` otherwise.

## ◆ is_active()

bool Gtk::Gesture::is_active | ( |  | ) | const

Returns `true` if the gesture is currently active.

A gesture is active meanwhile there are touch sequences interacting with it.

Since gtkmm 3.14:

Returns
  `true` if gesture is active.

## ◆ is_grouped_with()

bool Gtk::Gesture::is_grouped_with | ( | const Glib::RefPtr< Gesture > & | other | ) | const

Returns `true` if both gestures pertain to the same group.

Since gtkmm 3.14:

Parameters

  other | Another Gtk::Gesture.

Returns
  Whether the gestures are grouped.

## ◆ is_recognized()

bool Gtk::Gesture::is_recognized | ( |  | ) | const

Returns `true` if the gesture is currently recognized.

A gesture is recognized if there are as many interacting touch sequences as required by gesture, and Gtk::Gesture::signal_check() returned `true` for the sequences being currently interpreted.

Since gtkmm 3.14:

Returns
  `true` if gesture is recognized.

## ◆ operator=()

Gesture & Gtk::Gesture::operator= | ( | Gesture && | src | ) |
| noexcept

## ◆ property_n_points()

Glib::PropertyProxy_ReadOnly< unsigned int > Gtk::Gesture::property_n_points | ( |  | ) | const

The number of touch points that trigger recognition on this gesture,.

Since gtkmm 3.14:

Default value: 1

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_window() [1/2]

Glib::PropertyProxy< Glib::RefPtr< Gdk::Window > > Gtk::Gesture::property_window | ( |  | ) |

If non-`nullptr`, the gesture will only listen for events that happen on this Gdk::Window, or a child of it.

Since gtkmm 3.14:

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_window() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::Window > > Gtk::Gesture::property_window | ( |  | ) | const

If non-`nullptr`, the gesture will only listen for events that happen on this Gdk::Window, or a child of it.

Since gtkmm 3.14:

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ set_sequence_state()

bool Gtk::Gesture::set_sequence_state | ( | GdkEventSequence * | sequence,
|  | EventSequenceState | state
| ) |  |

Sets the state of sequence in gesture.

Sequences start in state Gtk::EVENT_SEQUENCE_NONE, and whenever they change state, they can never go back to that state. Likewise, sequences in state Gtk::EVENT_SEQUENCE_DENIED cannot turn back to a not denied state. With these rules, the lifetime of an event sequence is constrained to the next four:

- None
- None → Denied
- None → Claimed
- None → Claimed → Denied

Note
  Due to event handling ordering, it may be unsafe to set the state on another gesture within a Gtk::Gesture::signal_begin() signal handler, as the callback might be executed before the other gesture knows about the sequence. A safe way to perform this could be:

[C example ellipted]

If both gestures are in the same group, just set the state on the gesture emitting the event, the sequence will be already be initialized to the group's global state when the second gesture processes the event.

Since gtkmm 3.14:

Parameters

  sequence | A Gdk::EventSequence.
  state | The sequence state.

Returns
  `true` if sequence is handled by gesture, and the state is changed successfully.

## ◆ set_state()

bool Gtk::Gesture::set_state | ( | EventSequenceState | state | ) |

Sets the state of all sequences that gesture is currently interacting with.

See set_sequence_state() for more details on sequence states.

Since gtkmm 3.14:

Parameters

  state | The sequence state.

Returns
  `true` if the state of at least one sequence was changed successfully.

## ◆ set_window()

void Gtk::Gesture::set_window | ( | const Glib::RefPtr< Gdk::Window > & | window | ) |

Sets a specific window to receive events about, so gesture will effectively handle only events targeting window, or a child of it.

window must pertain to Gtk::EventController::get_widget().

Since gtkmm 3.14:

Parameters

  window | A Gdk::Window, or `nullptr`.

## ◆ signal_begin()

Glib::SignalProxy< void, GdkEventSequence * > Gtk::Gesture::signal_begin | ( |  | ) |

Slot Prototype:
  `void on_my_begin(GdkEventSequence* sequence)`

Flags: Run Last

This signal is emitted when the gesture is recognized. This means the number of touch sequences matches Gtk::Gesture::property_n_points(), and the Gtk::Gesture::signal_check() handler(s) returned #`true`.

Note
  These conditions may also happen when an extra touch (eg. a third touch on a 2-touches gesture) is lifted, in that situation sequence won't pertain to the current set of active touches, so don't rely on this being true.

Since gtkmm 3.14:

Parameters

  sequence | The Gdk::EventSequence that made the gesture to be recognized.

## ◆ signal_cancel()

Glib::SignalProxy< void, GdkEventSequence * > Gtk::Gesture::signal_cancel | ( |  | ) |

Slot Prototype:
  `void on_my_cancel(GdkEventSequence* sequence)`

Flags: Run Last

This signal is emitted whenever a sequence is cancelled. This usually happens on active touches when Gtk::EventController::reset() is called on gesture (manually, due to grabs...), or the individual sequence was claimed by parent widgets' controllers (see Gtk::Gesture::set_sequence_state()).

gesture must forget everything about sequence as a reaction to this signal.

Since gtkmm 3.14:

Parameters

  sequence | The Gdk::EventSequence that was cancelled.

## ◆ signal_end()

Glib::SignalProxy< void, GdkEventSequence * > Gtk::Gesture::signal_end | ( |  | ) |

Slot Prototype:
  `void on_my_end(GdkEventSequence* sequence)`

Flags: Run Last

This signal is emitted when gesture either stopped recognizing the event sequences as something to be handled (the Gtk::Gesture::signal_check() handler returned `false`), or the number of touch sequences became higher or lower than Gtk::Gesture::property_n_points().

Note
  sequence might not pertain to the group of sequences that were previously triggering recognition on gesture (ie. a just pressed touch sequence that exceeds Gtk::Gesture::property_n_points()). This situation may be detected by checking through Gtk::Gesture::handles_sequence().

Since gtkmm 3.14:

Parameters

  sequence | The Gdk::EventSequence that made gesture recognition to finish.

## ◆ signal_sequence_state_changed()

Glib::SignalProxy< void, GdkEventSequence *, EventSequenceState > Gtk::Gesture::signal_sequence_state_changed | ( |  | ) |

Slot Prototype:
  `void on_my_sequence_state_changed(GdkEventSequence* sequence, EventSequenceState state)`

Flags: Run Last

This signal is emitted whenever a sequence state changes. See Gtk::Gesture::set_sequence_state() to know more about the expectable sequence lifetimes.

Since gtkmm 3.14:

Parameters

  sequence | The Gdk::EventSequence that was cancelled.
  state | The new sequence state.

## ◆ signal_update()

Glib::SignalProxy< void, GdkEventSequence * > Gtk::Gesture::signal_update | ( |  | ) |

Slot Prototype:
  `void on_my_update(GdkEventSequence* sequence)`

Flags: Run Last

This signal is emitted whenever an event is handled while the gesture is recognized. sequence is guaranteed to pertain to the set of active touches.

Since gtkmm 3.14:

Parameters

  sequence | The Gdk::EventSequence that was updated.

## ◆ ungroup()

void Gtk::Gesture::ungroup | ( |  | ) |

Separates gesture into an isolated group.

Since gtkmm 3.14:

## ◆ unset_window()

void Gtk::Gesture::unset_window | ( |  | ) |

Undoes the effect of previous calls to set_window(), so the gesture will handle events targeting any Gdk::Window that pertains to Gtk::EventController::get_widget().

Since gtkmm 3.14:

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::Gesture > wrap | ( | GtkGesture * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.